//package com.cultural.heritage.controller.wxPayDemo;
//
//
//import com.google.gson.Gson;
//import com.wechat.pay.contrib.apache.httpclient.auth.Verifier;
//import jakarta.annotation.Resource;
//import jakarta.servlet.http.HttpServletRequest;
//import jakarta.servlet.http.HttpServletResponse;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.web.bind.annotation.PostMapping;
//import org.springframework.web.bind.annotation.RequestMapping;
//import org.springframework.web.bind.annotation.RestController;
//
//import java.util.HashMap;
//import java.util.Map;
//import java.util.concurrent.TimeUnit;
//
//@RestController
//@RequestMapping("/api/wx-pay/notify")
//@Slf4j
//public class WxPayNotifyController {
//    @Resource
//    private Verifier verifier;
//
//    /**
//     * 订单支付成功回调
//     */
//    @PostMapping("/native")
//    public String nativeNotify(HttpServletRequest request, HttpServletResponse response) {
//
//        Gson gson = new Gson();
//        Map<String, String> map = new HashMap<>();//应答对象
//
//        try {
//            //处理通知参数
//            String body = HttpUtils.readData(request);
//            Map<String, Object> bodyMap = gson.fromJson(body, HashMap.class);
//            String requestId = (String) bodyMap.get("id");
//            log.info("支付通知的id ===> {}", requestId);
//
//            //签名的验证
//            WechatPay2ValidatorForRequest wechatPay2ValidatorForRequest
//                    = new WechatPay2ValidatorForRequest(verifier, requestId, body);
//            if (!wechatPay2ValidatorForRequest.validate(request)) {
//
//                log.error("通知验签失败");
//                //失败应答
//                response.setStatus(500);
//                map.put("code", "ERROR");
//                map.put("message", "通知验签失败");
//                return gson.toJson(map);
//            }
//            log.info("通知验签成功");
//
//            //处理订单 这里可以对订单进行处理 比如订单支付成功 修改数据库订单表订单状态为已支付
////            processOrder(bodyMap);
//
//            //应答超时
//            //模拟接收微信端的重复通知
//            TimeUnit.SECONDS.sleep(5);
//
//            //成功应答
//            response.setStatus(200);
//            map.put("code", "SUCCESS");
//            map.put("message", "成功");
//            return gson.toJson(map);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            //失败应答
//            response.setStatus(500);
//            map.put("code", "ERROR");
//            map.put("message", "失败");
//            return gson.toJson(map);
//        }
//    }
//
//    @PostMapping("/refunds")
//    public String refundsNotify(HttpServletRequest request, HttpServletResponse response){
//
//        log.info("退款通知执行");
//        Gson gson = new Gson();
//        Map<String, String> map = new HashMap<>();//应答对象
//
//        try {
//            //处理通知参数
//            String body = HttpUtils.readData(request);
//            Map<String, Object> bodyMap = gson.fromJson(body, HashMap.class);
//            String requestId = (String)bodyMap.get("id");
//            log.info("支付通知的id ===> {}", requestId);
//
//            //签名的验证
//            WechatPay2ValidatorForRequest wechatPay2ValidatorForRequest
//                    = new WechatPay2ValidatorForRequest(verifier, requestId, body);
//            if(!wechatPay2ValidatorForRequest.validate(request)){
//
//                log.error("通知验签失败");
//                //失败应答
//                response.setStatus(500);
//                map.put("code", "ERROR");
//                map.put("message", "通知验签失败");
//                return gson.toJson(map);
//            }
//            log.info("通知验签成功");
//
//            //处理退款单 订单退款成功 修改订单表中订单状态为已退款
////            processRefund(bodyMap);
//
//            //成功应答
//            response.setStatus(200);
//            map.put("code", "SUCCESS");
//            map.put("message", "成功");
//            return gson.toJson(map);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            //失败应答
//            response.setStatus(500);
//            map.put("code", "ERROR");
//            map.put("message", "失败");
//            return gson.toJson(map);
//        }
//    }
//}
